
Ruby - Bug #9861

BSD_vfprintf precsion doesn't work at shorter string

05/25/2014 02:49 AM - nobu (Nobuyoshi Nakada)

Status: Closed   

Priority: Normal   

Assignee: nobu (Nobuyoshi Nakada)   

Target version: 2.2.0   

ruby -v: 1.4.0 or later Backport: 2.0.0: DONE, 2.1: DONE

Description

ruby_snprintfなどで"%s"に精度を指定してその精度よりも短い文字列を渡すと、本来の長さが無視されて精度まで'\0'が詰められます。

/* t.c */

#include <ruby/ruby.h>

int main(void)

{

    char buf[26];

    ruby_snprintf(buf, sizeof(buf), "%.2s", "s");

    printf("[%.2x][%.2x][%.2x]\n", buf[0], buf[1], buf[2]);

    return 0;

}

 
$ make t LDLIBS='$(LIBRUBYARG_STATIC) $(LIBS)'

$ ./t

[73][00][00]

 最初のmissing/vsnprintf.cからあるようなので、1.4.0以降すべてのバージョンにあるバグだと思います。

Associated revisions

Revision bae87a479016504577b7def06f38615837f12b50 - 05/25/2014 02:56 AM - nobu (Nobuyoshi Nakada)

vsnprintf.c: fix string precision

vsnprintf.c (BSD_vfprintf): fix string width when precision is

given.  as the result of memchr is NULL or its offset from the

start cannot exceed the size, the comparison was always false.

[ruby-core:62737] [Bug #9861]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@46098 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision bae87a47 - 05/25/2014 02:56 AM - nobu (Nobuyoshi Nakada)

vsnprintf.c: fix string precision

vsnprintf.c (BSD_vfprintf): fix string width when precision is

given.  as the result of memchr is NULL or its offset from the

start cannot exceed the size, the comparison was always false.

[ruby-core:62737] [Bug #9861]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@46098 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 4e057b91576ce7be07c9f76ac9ab51b6e0b1fb15 - 06/27/2014 08:46 AM - U.Nakamura 

merge revision(s) 46098: [Backport #9861]

    * vsnprintf.c (BSD_vfprintf): fix string width when precision is

      given.  as the result of `memchr` is NULL or its offset from the

      start cannot exceed the size, the comparison was always false.

      [ruby-core:62737] [Bug #9861]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_0_0@46582 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 4e057b91 - 06/27/2014 08:46 AM - U.Nakamura 

merge revision(s) 46098: [Backport #9861]
    * vsnprintf.c (BSD_vfprintf): fix string width when precision is

      given.  as the result of `memchr` is NULL or its offset from the

      start cannot exceed the size, the comparison was always false.

      [ruby-core:62737] [Bug #9861]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_0_0@46582 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 0caeba64c30e6746870328a0d7da6250b0a3773c - 06/29/2014 05:17 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) r46098: [Backport #9861]

    * vsnprintf.c (BSD_vfprintf): fix string width when precision is

      given.  as the result of `memchr` is NULL or its offset from the

      start cannot exceed the size, the comparison was always false.

      [ruby-core:62737] [Bug #9861]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@46611 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 0caeba64 - 06/29/2014 05:17 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) r46098: [Backport #9861]

    * vsnprintf.c (BSD_vfprintf): fix string width when precision is

      given.  as the result of `memchr` is NULL or its offset from the

      start cannot exceed the size, the comparison was always false.

      [ruby-core:62737] [Bug #9861]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@46611 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 05/25/2014 02:56 AM - nobu (Nobuyoshi Nakada)

- Status changed from Assigned to Closed

- % Done changed from 0 to 100

Applied in changeset r46098.

vsnprintf.c: fix string precision

vsnprintf.c (BSD_vfprintf): fix string width when precision is

given.  as the result of memchr is NULL or its offset from the

start cannot exceed the size, the comparison was always false.

[ruby-core:62737] [Bug #9861]

#2 - 06/27/2014 08:46 AM - usa (Usaku NAKAMURA)

backported into ruby_2_0_0 at r46582.

#3 - 06/27/2014 08:46 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.0.0: REQUIRED, 2.1: REQUIRED to 2.0.0: DONE, 2.1: REQUIRED

#4 - 06/29/2014 05:17 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.0.0: DONE, 2.1: REQUIRED to 2.0.0: DONE, 2.1: DONE

Backported into ruby_2_1 branch at r46611.
